/*
---
description: Fifteen

license: MIT-style

authors:
- Pavel Lysyuk (http://www.meccanocode.ru)

requires:
- core/1.3.2: '*'

provides: fifteen()

...
*/

Element.implement({
  fifteen: function(opt){
    var options = {
      'rows': 4,
      'cols': 4,
      'cellClass': 'cell'
    };
    $extend(options, opt);
    var rows = options.rows;
    var cols = options.cols;
    var initialized = false;
    var table15 = new Element('table');
    this.grab(table15);
    for(var r = 0; r < rows; r++) {
      var tr15 = new Element('tr');
      table15.grab(tr15);
      for(var c = 0; c < cols; c++) {
        var td15 = new Element('td', {
          'class': options.cellClass,
          'id': 'c' + (r * cols + c),
          events: {
            click: function() {
              var t = null, l = null, b = null, r = null;
              var n = $(this).get('id').substring(1);
              var v = $(this).get('text');
              var row = parseInt(n / cols);
              var col = n - row * cols;
              if(row > 0) {
                t = $('c' + ((row - 1) * cols + col));
              }
              if(row < rows - 1) {
                b = $('c' + ((row + 1) * cols + col));        
              }
              if(col > 0) {
                l = $('c' + (row * cols + col - 1));  
              }
              if (col < cols - 1) {
                r = $('c' + (row * cols + col + 1));  
              }
              if(t && (t.get('text') == '')) {
                $(this).set('text', '');
                t.set('text', v);
              } else if(l && (l.get('text') == '')) {
                $(this).set('text', '');
                l.set('text', v);        
              } else if(b && (b.get('text') == '')) {
                $(this).set('text', '');
                b.set('text', v);        
              } else if(r && (r.get('text') == '')) {
                $(this).set('text', '');
                r.set('text', v);        
              }
              var result = true;
              for(var i = 1; i < rows * cols - 1; i++) {
                result = result && (parseInt($('c' + i).get('text')) > parseInt($('c' + (i - 1)).get('text')));
              }
              if((result) && (initialized)) {
                alert('Поздравляем! Вы решили головоломку!');
              }
            }
          }
        });
        tr15.grab(td15);
      }
    }
    var i;
    for(i = 1; i < rows * cols; i++) {
      $('c' + (i - 1)).set('text', i);
    }
    for(i = 0; i < 500; i++) {
      var empty = $$('.' +  options.cellClass + ':empty').getLast();
      var n = empty.get('id').substring(1);
      var row = parseInt(n / cols);
      var col = n - row * cols;
      var variants = new Array();
      if(row > 0) {
        variants.include($('c' + ((row - 1) * cols + col)));
      }
      if(row < rows - 1) {
        variants.include($('c' + ((row + 1) * cols + col)));        
      }
      if(col > 0) {
        variants.include($('c' + (row * cols + col - 1)));  
      }
      if (col < cols - 1) {
        variants.include($('c' + (row * cols + col + 1)));  
      }
      variants.getRandom().fireEvent('click');
    }
    initialized = true;
  }
});